﻿TooCool = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceHook-2.1", "Metrognome-2.0", "AceDB-2.0")
TooCool:RegisterChatCommand({"/toocool"})

TooCool:RegisterDB("TooCoolDB")

function TooCool:OnInitialize()
    self.frames = { }
    self.cooldowns = { }
    
    self:RegisterMetro("TooCool", self.CheckCooldowns, 0.6, self)
    self:Hook("CooldownFrame_SetTimer")
end

function TooCool:OnEnable()
    ----------------------------------------------------
    
    -- FlexBar buttons
    self:CreateFrames( self:GenerateFlexBarButtonList() )
    
    -- Default Blizzard buttons
    --self:CreateFrames( self:GenerateBlizzardButtonList() )
    ----------------------------------------------------
    
    self:OnDisable()
    
    self:CheckCooldowns()
    
    self:StartMetro("TooCool")
end

function TooCool:OnDisable()
    for frame in self.frames do
        if self.frames[frame] then
            self.frames[frame]:Hide()
        end
    end
    self:StopMetro("TooCool")
end

-- FlexBar frames
function TooCool:GenerateFlexBarButtonList()
    local _flexBarFrames = { }
    for i=1,120 do
        _flexBarFrames[i] = "FlexBarButton"..i
    end
    return _flexBarFrames
end

-- Blizzard frames
function TooCool:GenerateBlizzardButtonList()
    local _blizzardFrames = { }
    for i=1,12 do
        _blizzardFrames[i] = "ActionButton"..i
    end
    for i=table.getn(_blizzardFrames)+1, table.getn(_blizzardFrames)+12 do
        _blizzardFrames[i] = "BonusActionButton"..i
    end
    for i=table.getn(_blizzardFrames)+1,table.getn(_blizzardFrames)+10 do
        _blizzardFrames[i] = "ShapeshiftButton"..i
    end
    for i=table.getn(_blizzardFrames)+1,table.getn(_blizzardFrames)+12 do
        _blizzardFrames[i] = "MultiBarBottomLeftButton"..i
    end
    for i=table.getn(_blizzardFrames)+1,table.getn(_blizzardFrames)+12 do
        _blizzardFrames[i] = "MultiBarBottomRightButton"..i
    end
    for i=table.getn(_blizzardFrames)+1,table.getn(_blizzardFrames)+12 do
        _blizzardFrames[i] = "MultiBarRightButton"..i
    end
    for i=table.getn(_blizzardFrames)+1,table.getn(_blizzardFrames)+12 do
        _blizzardFrames[i] = "MultiBarLeftButton"..i
    end
    
    for i in _blizzardFrames do
        self:Print(_blizzardFrames[i])
    end
    return _blizzardFrames
end

function TooCool:CooldownFrame_SetTimer(this, start, duration, enable)
    self.cooldowns[this:GetName()] = { } --getname()="ActionButton12Cooldown"
    self.cooldowns[this:GetName()].start = start
    self.cooldowns[this:GetName()].duration = duration
    self.cooldowns[this:GetName()].enable = enable
    
    self.hooks["CooldownFrame_SetTimer"](this, start, duration, enable)
end

function TooCool:CreateFrames(frameArray)
    for i in frameArray do
        local _aButton = getglobal(frameArray[i])
        if (_aButton) then
        
            f = CreateFrame("Frame", nil, _aButton)
            f:ClearAllPoints()
            f:SetHeight(32)
            f:SetWidth(32)
            f:SetPoint("CENTER", _aButton, "CENTER", 0, 0)
            f:Show()
            
            f.text = f:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
            f.text:ClearAllPoints()
            f.text:SetJustifyH("CENTER")
            f.text:SetJustifyV("MIDDLE")
            f.text:SetPoint("CENTER", f, "CENTER", 0, 0);
            f.text:Show()
            
            self.frames[_aButton:GetName()] = f
        end
    end
end

function TooCool:CheckCooldowns()
    for frame in self.frames do
        if (  self.frames[frame] and 
              getglobal(frame) and 
              getglobal(frame):IsVisible() and 
              self.cooldowns[frame.."Cooldown"]) then
            local start = self.cooldowns[frame.."Cooldown"].start
            local duration = self.cooldowns[frame.."Cooldown"].duration
            local enable = self.cooldowns[frame.."Cooldown"].enable

            local remaining = duration + start - GetTime() 
             
            if remaining <= 0 then
                self.frames[frame].text:SetText( "" )
                self.frames[frame]:Hide()
            elseif duration > 2.0 then
                remaining = math.ceil(remaining)
                if remaining >= 60 then
                    remaining = math.ceil(remaining/60).."m"
                end
            
                self.frames[frame]:Show()
                self.frames[frame].text:SetText( remaining )
            end  
        end
    end
end